<!DOCTYPE html>
<html>
<head>
    <title>Button Soup</title>
    <meta charset="UTF-8">
    <meta name="description" content="recipes, ingredients, cooking, vegetarian, vegan">
    <script src="./static/react-16.10.2.min.js"></script>
    <script src="./static/react-dom-16.10.2.min.js"></script>
    <script src="./static/polyfills.js"></script>
    <script src="./static/utils.js"></script>
    <link rel="stylesheet" href="./static/style.css" type="text/css">
</head>
<!--
1gram of potatoes = 0.1 average potato
dont show ingredient grams, but more user-friendly units instead
-->
<body>
    <div class="topBar">
        <a href="/"><img src="./static/logo.png" id="logo"></a>
        <a href="/auth/login" class="topBarButton">Login / Register</a>
        <a id="submitRecipeButton" href="/admin/recipe" class="topBarButton">Submit Recipe</a>
        <a id="allergenButton" href="#" class="topBarButton" onclick="showHideAllergens()">Show Allergens</a>
        <a id="aboutUs" href="#" class="topBarButton" onclick="showContactUs()">About Us</a>
    </div>
    <div class="containerGroup">
        <div class="leftSideContainer">
            <div id="selectIngredients">
                <img src="./static/select_ingredients.png"/>
            </div>
        </div>
        <div class="middleContainer">
            <div id="root"></div>
       </div>
       <div class="rightSideContainer">
           <img src="./static/set.png" id="knife" />
       </div>
    </div>
<script>

var h = React.createElement;
var div = h.bind(null, "div");

var buttonSoupState = {
    recipes: [], // all recipes in the system
    ingredients: [], // all ingredients in the system
    selectedIngredients: [],
    selectableIngredients: [],
    recipeTilesPage: 0, // resembles page id for found recipes container
    amountOfServings: 1, // useful for calculating calories and nutrients and amount of needed ingredients
    foundRecipes: [], // array of recipe names which match selected criteria
    openedRecipeName: undefined, // any recipe name
    showAllergenOverlay: false,
    inputs: {
        vegetarian: false,
        vegan: false,
        name: "",
    },
    domNodes: {
        name: undefined,
    }
};

function ButtonSoup() {
    var state = buttonSoupState;
    return (
        div({ className: "buttonSoup" },
            SearchBar(state),
            h("fieldset", { className: "selectedIngredientsBox" },
                h("legend", {}, "Selected ingredients"),
                SelectedIngredients(state)
            ),
            div({ className: "recipesTilesContainerWrapper" },
                FoundRecipes(state)
            ),
            RecipeDialog(state),
            AllergenOverlay(state)
        )
    );
}

xhrGet("/admin/all_recipes_and_ingredients", function (data) {
    onDataLoaded(buttonSoupState, JSON.parse(data));
});

var SELECTABLE_INGREDIENTS_COUNT = 28;

// many to many mapping
function findAllRecipesByIngredients(state, ingredients) {
    var ingredientIds = ingredients.map(function(ingredient) { return ingredient.ingredient_id });
    return state.recipes.reduce(function(memo, recipe) {
        return getIngredientIdsFromRecipe(recipe).every(function (recipeIngredientId) {
            return ingredientIds.indexOf(recipeIngredientId) !== -1;
        }) ? memo.concat(recipe) : memo;
    }, []);
}

var root = document.getElementById('root');

function renderApp(state) {
    ReactDOM.render(h(ButtonSoup), root);
}

function onDataLoaded(state, data) {
    state.selectableIngredients = findNonSelectedIngredientsByAttributes(data.ingredients, [], {
        vegan: state.inputs.vegan,
        vegetarian: state.inputs.vegetarian
    }).slice(0, SELECTABLE_INGREDIENTS_COUNT);

    state.ingredients = data.ingredients;
    state.recipes = data.recipes;

    renderApp(state);
}

function getNonSelectedIngredient(state) {
    var list = findNonSelectedIngredientsByAttributes(state.ingredients, state.selectedIngredients, state.inputs);
    var result = list.find(function(ingredient) {
        return state.selectableIngredients.indexOf(ingredient) === -1;
    });
    return result;
}

function onSearchIngredientsChanged(state) {
    state.selectableIngredients = findNonSelectedIngredientsByAttributes(
        state.ingredients,
        state.selectedIngredients,
        state.inputs
    ).slice(0, SELECTABLE_INGREDIENTS_COUNT);
}

function onIngredientClick(state, ingredient) {
    if (state.inputs.name) {
        state.inputs.name = "";
        state.domNodes.name.value = "";
        onSearchIngredientsChanged(state);
    }

    if (state.selectedIngredients.indexOf(ingredient) === -1) {
        var replacementIngredient = findNonSelectedIngredientsByAttributes(state.ingredients, state.selectedIngredients, {
            vegan: state.inputs.vegan,
            vegetarian: state.inputs.vegetarian
        }).find(function (i) {
            return state.selectableIngredients.indexOf(i) === -1;
        });

        var index = state.selectableIngredients.indexOf(ingredient);

        if (replacementIngredient) {
            state.selectableIngredients.splice(index, 1, replacementIngredient);
        } else {
            state.selectableIngredients.splice(index, 1);
        }

        state.selectedIngredients.push(ingredient);
    } else {
        if (state.selectableIngredients.length < SELECTABLE_INGREDIENTS_COUNT) {
            state.selectableIngredients.push(ingredient);
        }
        state.selectedIngredients.splice(state.selectedIngredients.indexOf(ingredient), 1);
    }

    renderApp(state);
}

function SearchBar(state) {
    var vegetarianCheckBoxNode = React.useRef(null);
    var veganCheckBoxNode = React.useRef(null);

    return (
        div({ className: "searchBar" },
            AutoCompleteInput(state),
            h("input", {
                ref: vegetarianCheckBoxNode,
                id: "vegetarian",
                type: "checkbox",
                className: "vegetarian",
                onChange: function() {
                    state.inputs.vegetarian = vegetarianCheckBoxNode.current.checked;

                    if (state.inputs.vegetarian) {
                        state.selectableIngredients = state.selectableIngredients.reduce(function (memo, ingredient) {
                            if (ingredient.vegetarian) {
                                memo.push(ingredient);
                            } else {
                                var replacementIngredient = getNonSelectedIngredient(state);
                                replacementIngredient && memo.push(replacementIngredient);
                            }
                            return memo;
                        }, []);
                    } else {
                        onSearchIngredientsChanged(state);
                    }

                    renderApp(state);
                }
            }),
            h("label", { className: "checkboxtext", for: "vegetarian" }, "Vegetarian only"),
            h("input", {
                ref: veganCheckBoxNode,
                id: "vegan",
                type: "checkbox",
                className: "vegan",
                onChange: function() {
                    state.inputs.vegan = veganCheckBoxNode.current.checked;

                    if (state.inputs.vegan) {
                        state.selectableIngredients = state.selectableIngredients.reduce(function(memo, ingredient) {
                            if (ingredient.vegetarian && ingredient.vegan) {
                                memo.push(ingredient);
                            } else {
                                var replacementIngredient = getNonSelectedIngredient(state);
                                replacementIngredient && memo.push(replacementIngredient);
                            }
                            return memo;
                        }, []);
                    } else {
                        onSearchIngredientsChanged(state);
                    }
                    renderApp(state);
                }
            }),
            h("label", { className: "checkboxtext", for: "vegan" }, "Vegan only")
        )
    )
}

function AllergenOverlay(state) {
    var allergens = [
        "Cereals containing Gluten", "Crustaceans", "Eggs", "Fish", "Peanuts", "Soybeans", "Milk (including lactose)",
        "Nuts", "Celery (including celeriac)", "Mustard", "Sesame", "Sulphur dioxide/sulphites", "Lupin", "Molluscs"
    ];

    return (
        div({ className: classNames("allergenDialog", { visible: state.showAllergenOverlay }) },
            div({ className: "allergens" },
                h("ul", null, allergens.map(function(allergen) {
                    return h("li", null, allergen);
                }))
            ),
            div({ className: "closeButton", onClick: function() {
                showHideAllergens(state);
            }}, "×")
        )
    );
}

function Ingredient(state, ingredient) {
    var attrs = {
        className: "ingredient",
        onClick: function () {
            onIngredientClick(state, ingredient);
        },
    };
    return div(attrs, ingredient.name);
}

function SelectedIngredients(state) {
    if (state.selectedIngredients.length === 0) {
        return div({}, "No ingredients have been selected");
    }

    return state.selectedIngredients.map(function(ingredient) {
        return Ingredient(state, ingredient);
    });
}

function findNonSelectedIngredientsByAttributes(ingredients, selectedIngredients, attributes) {
    return ingredients.filter(function (ingredient) {
        return (
            (attributes.vegan
                ? ingredient.vegan
                : true
            )
            && (attributes.vegetarian
                ? ingredient.vegetarian
                : true
            )
            && (attributes.name !== undefined
                ? new RegExp(attributes.name, "i").test(ingredient.name)
                : true
            )
            && selectedIngredients.indexOf(ingredient) === -1
        );
    });
}

function RecipeTile(recipe, options) {
    return h(
        "div", {
            className: classNames(["recipeTile", { lastRow: options.lastRow, lastColumn: options.lastColumn }]),
            onClick: function () { showHideRecipe(recipe.name) }
        }, [
            h("img", { src: "./static/images/recipes/thumbnails/" + recipe.thumbnail_url }),
            h("div", { className: "details" }, [
                h("div", { className: "name" }, capitalize(recipe.name)),
                h("div", { className: "ingredients", }, Object.keys(recipe.ingredients).map(function(ingredientName) {
                    return capitalize(ingredientName);
                }).join(", "))
            ])
        ]
    );
}

function onRecipeTilesRightClick(state) {
    state.recipeTilesPage += 1;
    renderApp(state);
}

function onRecipeTilesLeftClick(state) {
    state.recipeTilesPage -= 1;
    renderApp(state);
}

function setFoundRecipes(state, foundRecipes) {
    state.foundRecipes = foundRecipes;
}

var RecipeLoadingState = {
    LOADED: "LOADED",
    LOADING: "LOADING",
};

function Loader() {
    return div({ className: "loaderContainer" },
        div({ className: "loader" })
    );
}

function loadRecipeDescription(state, recipe) {
    if ([RecipeLoadingState.LOADING, RecipeLoadingState.LOADED].indexOf(recipe.loadingState) === -1) {
        recipe.loadingState = RecipeLoadingState.LOADING;
        xhrGet("/admin/recipes/" + recipe.recipe_id, function (data) {
            recipe.description = JSON.parse(data).description;
            recipe.loadingState = RecipeLoadingState.LOADED;

            if (recipe.name === state.openedRecipeName) {
                renderApp(state);
            }
        });
    }
}

function RecipeDialog(state) {
    return (
        div({ className: classNames("recipeDialog", { visible: state.openedRecipeName }) },
            div({ className: "recipeContent" },
                RecipeOverlay(state)
            ),
            div({ className: "closeButton", onClick: function () {
                state.openedRecipeName = undefined;
                renderApp(state);
            }}, "×")
        )
    );
}

function clamp(min, value, max) {
    return Math.min(Math.max(min, value), max);
}

function AutoCompleteInput(state) {
    var nameInputNode = React.useRef(null);
    var indexState = React.useState(0);
    var selectedIndex = indexState[0];
    var setSelectedIndex = indexState[1];
    var ingredients = state.inputs.name
        ? findNonSelectedIngredientsByAttributes(state.ingredients, state.selectedIngredients, state.inputs)
        : [];

    var handleKeyboardInput = React.useCallback(function(event) {
        if (event.which === 38 || event.code === "ArrowUp") {
            setSelectedIndex(clamp(0, selectedIndex - 1, ingredients.length - 1));
        } else if (event.which === 40 || event.code === "ArrowDown") {
            setSelectedIndex(clamp(0, selectedIndex + 1, ingredients.length - 1));
        } else if (event.which === 13 || event.code === "Enter") {
            ingredients[selectedIndex] && onIngredientClick(state, ingredients[selectedIndex]);
            setSelectedIndex(0);
        }
    }, [selectedIndex, ingredients]);

    React.useEffect(() => {
        window.addEventListener("keyup", handleKeyboardInput);
        return function() {
            window.removeEventListener('keyup', handleKeyboardInput);
        };
    }, [handleKeyboardInput]);

    state.domNodes.name = nameInputNode.current;

    return (
        h("div", { className: "autoCompleteInput" },
            h("input", {
                className: "textInput",
                placeholder: "Search ingredients...",
                autocomplete: "off",
                ref: nameInputNode,
                onKeyUp: function() {
                    state.inputs.name = nameInputNode.current.value;
                    renderApp(state);
                }
            }),
            h("ul", { className: classNames("list", { visible: ingredients.length }) },
                ingredients.slice(0, 4).map(function(ingredient, index) {
                    return h(
                        "li",
                        {
                            className: classNames("item", { focused: index === selectedIndex }),
                            onClick: function() {
                                onIngredientClick(state, ingredient);
                            }
                        },
                        ingredient.name
                    );
                })
            )
        )
    );
}

function FoundRecipes(state) {
    var recipes = findAllRecipesByIngredients(state, state.selectedIngredients);
    var recipesPerRow = 4;
    var numberOfRows = 1;
    var recipesPerPage = recipesPerRow * numberOfRows;
    var lastRowStartIndex = recipesPerPage - recipesPerPage - (recipesPerPage % recipesPerRow) - 1;
    var startIndex = state.recipeTilesPage * recipesPerPage;
    var endIndex = (state.recipeTilesPage + 1) * recipesPerPage;
    var total = recipes.length;
    var start = state.recipeTilesPage * recipesPerPage + 1;
    var end = start + Math.min(recipesPerPage, (total - (recipesPerPage * state.recipeTilesPage))) - 1;

    setFoundRecipes(state, recipes);

    recipes.forEach(function(recipe) {
        loadRecipeDescription(state, recipe);
    });

    return (
        div({ className: "recipesTilesContainer"}, [
            h("h1", { className: "recipesTitle" }, "Recipes"),
            div({ className: "controls" }, [
                h(
                    "div",
                    {
                        className: classNames("scrollLeft", { disabled: start === 1 || total === 0 }),
                        onClick: function () { onRecipeTilesLeftClick(state) }
                    },
                    h("img", { src: "./static/chevron_left.png", style: { width: "20px" } })
                ),
                h("div", { className: "foundRecipesCount" }, recipes.length !== 0
                    ? "Showing " + start + "-" + end + "/" + total + " recipes"
                    : "No recipes found. Showing suggestes recipes"
                ),
                h(
                    "div",
                    {
                        className: classNames(["scrollRight", { disabled: end === total || total === 0 }]),
                        onClick: function() { onRecipeTilesRightClick(state); }
                    },
                    h("img", { src: "./static/chevron_right.png", style: { width: "20px" } })
                )
            ]),
            h("div", { className: "recipesTiles" },
                recipes.length
                    ? recipes.slice(startIndex, endIndex).map(function(recipe, i) {
                        return RecipeTile(recipe, {
                            lastRow: lastRowStartIndex < i,
                            lastColumn: (i + 1) % recipesPerRow === 0,
                        });
                    })
                    : h("div", { className: "recipesTilesContainer" },
                        h("span", { className: "noRecipesInfo" }, "No recipes found. Select more ingredients")
                    )
            )
        ])
    );
}

function getIngredientIdsFromRecipe(recipe) {
    return recipe.ingredients.map(function(ingredient) { return ingredient.ingredient_id; });
}

function RecipeOverlay(state) {
    if (!state.openedRecipeName) {
        return "RECIPE NOT FOUND - " + state.openedRecipeName;
    }

    var recipe = state.recipes.find(function(r) { return r.name === state.openedRecipeName });
    var ingredientIds = getIngredientIdsFromRecipe(recipe);

    var nutrientValues = ingredientIds.reduce(function(memo, ingredientId) {
        var ingredient = state.ingredients.find(function(i) { return i.ingredient_id === ingredientId; });
        ["carbohydrates", "protein", "fat", "fibre"].forEach(function(nutrient) {
            !memo[nutrient] && (memo[nutrient] = 0);
            ingredient[nutrient] && (memo[nutrient] += ingredient[nutrient]);
        });

        return memo;
    }, {});

    var recipeIndex = state.foundRecipes.findIndex(function(r) { return r.name === state.openedRecipeName });

    return div({ className: "recipeContainer" }, [
        div({ className: "header" }, [
            div({ className: "thumbnailContainer" },
                h("img", {
                    src: recipe.thumbnail_url
                        ? "./static/images/recipes/thumbnails/" + recipe.thumbnail_url
                        : "./static/images/default_recipe_thumbnail.jpeg"
                }),
            ),
            h(
                "span",
                {
                    className: classNames(["arrow", { disabled: recipeIndex === 0 }]),
                    onClick: function() { onRecipeTitleLeftArrowClick(state) }
                },
                "\u21E6"
            ),
            h("h1", { className: "title" }, capitalize(recipe.name)),
            h(
                "span",
                {
                    className: classNames(["arrow", { disabled: recipeIndex === state.foundRecipes.length - 1 }]),
                    onClick: function() { onRecipeTitleRightArrowClick(state) }
                },
                "\u21E8"
            )
        ]),
        h("h2", {}, "Ingredients:"),
        h("ul", { className: "ingredients" }, ingredientIds.map(function(ingredientId) {
            var ingredient = state.ingredients.find(function (i) { return i.ingredient_id === ingredientId; });
            var recipeIngredient = recipe.ingredients.find(function (i) { return i.ingredient_id === ingredientId; });

            return h(
                "li",
                {},
                capitalize(ingredient.name) + " " + recipeIngredient.amount + " " + recipeIngredient.note
            );
        })),
        h("ul", { className: "nutrients" }, Object.keys(nutrientValues).reduce(function(memo, nutrient) {
            if (nutrientValues[nutrient]) {
                return memo.concat(h(
                    "li",
                    {},
                    capitalize(nutrient) + " " + (nutrientValues[nutrient] * state.amountOfServings) + "g"
                ));
            }
            return memo;
        }, [])),
        div({ className: "arrows" }, [
            div({
                className: classNames(["arrowLeft",  { disabled: state.amountOfServings === 1 }]),
                onClick: function () { onServingsLeftArrowClick(state) }
            }),
            div({ className: "servingsCount" }, "Servings: " + state.amountOfServings),
            div({
                className: classNames(["arrowRight", { disabled: state.amountOfServings === 100 }]),
                onClick: function () { onServingsRightArrowClick(state) }
            }),
        ]),
        recipe.gramsPerServing && div({ className: "gramsPerServing" }, "Grams per serving: " + recipe.gramsPerServing),
        div({ className: "description" },
            div(
                recipe.loadingState === RecipeLoadingState.LOADED
                    ? { dangerouslySetInnerHTML: { __html: recipe.description } }
                    : {},
                recipe.loadingState === RecipeLoadingState.LOADED ? null : Loader()
            )
        )
    ]);
}

function onRecipeTitleLeftArrowClick(state, event) {
    event && event.preventDefault();

    var index = state.foundRecipes.findIndex(function(recipe) { return recipe.name === state.openedRecipeName });
    if (index === -1 || index === 0 || state.foundRecipes.length < 2) {
        return;
    } else {
        setOpenedRecipeName(state, state.foundRecipes[index - 1].name);
        renderApp(state);
    }
}

function onRecipeTitleRightArrowClick(state, event) {
    event && event.preventDefault();

    var index = state.foundRecipes.findIndex(function(recipe) { return recipe.name === state.openedRecipeName });
    if (index === -1 || index === state.foundRecipes.length - 1 || state.foundRecipes.length < 2) {
        return;
    } else {
        setOpenedRecipeName(state, state.foundRecipes[index + 1].name);
        renderApp(state);
    }
}

function onServingsLeftArrowClick(state) {
    if (state.amountOfServings > 1) {
        state.amountOfServings -= 1;
        renderApp(state);
    }
}

function onServingsRightArrowClick(state) {
    if (state.amountOfServings < 100 ) {
        state.amountOfServings += 1;
        renderApp(state);
    }
}

function setOpenedRecipeName(state, recipeName) {
    state.openedRecipeName = recipeName;
}

function showHideRecipe(recipeName) {
    var state = buttonSoupState;
    if (state.openedRecipeName === undefined) {
        setOpenedRecipeName(state, recipeName);
        state.openedRecipeName = recipeName;
    } else {
        state.amountOfServings = 1;
        state.openedRecipeName = undefined;
    }
    renderApp(state);
}

function showHideAllergens() {
    var state = buttonSoupState;
    state.showAllergenOverlay = !state.showAllergenOverlay;
    renderApp(state);
}

document.addEventListener("keydown", function(event) {
    var state = buttonSoupState;
    if (event.which === 27 || event.code === "Escape") {
        if (state.showAllergenOverlay) {
            state.showAllergenOverlay = false;
            renderApp(state);
        }
        if (state.openedRecipeName) {
            state.openedRecipeName = undefined;
            state.amountOfServings = 1;
            renderApp(state);
        }
    } else if (event.which === 39 || event.code === "ArrowRight") {
        onRecipeTitleRightArrowClick(state, event);
    } else if (event.which === 37 || event.code === "ArrowLeft") {
        onRecipeTitleLeftArrowClick(state, event);
    }
});

document.addEventListener("keyup", function(event) {
    var state = buttonSoupState;
    if (event.which === 191 || event.code === "Slash") {
        state.domNodes.name.focus();
    }
});

</script>
</body>
</html>
